Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -2802,6 +3467,56 @@
         } 
 }
 
+static inline void dasd_do_hotplug_event (dasd_device_t* device, int eventid) {
+#ifdef CONFIG_HOTPLUG
+        int i;
+        char *argv[3], *envp[8];
+        char devno[20],major[20],minor[20],devname[26],action[20];
+
+        /* setup command line arguments */
+        i=0;
+        argv[i++] = hotplug_path;
+        argv[i++] = "dasd";
+        argv[i++] = 0;
+
+        /* minimal environment */
+        i=0;
+        envp[i++] = "HOME=/";
+        envp[i++] = "PATH=/sbin:/bin:/usr/sbin:/usr/bin";
+        
+        /* device information and event*/
+        sprintf (devno, "DEVNO=%04x", device->devinfo.devno);
+        sprintf (major, "MAJOR=%d", MAJOR(device->kdev));
+        sprintf (minor, "MINOR=%d", MINOR(device->kdev));
+        sprintf (devname, "DASDNAME=%s",device->name);
+        switch (eventid) {
+        case DASD_HOTPLUG_EVENT_ADD:
+                sprintf (action,"ACTION=add");
+                break;
+        case DASD_HOTPLUG_EVENT_REMOVE:
+                sprintf (action,"ACTION=remove");
+                break;
+        case DASD_HOTPLUG_EVENT_PARTCHK:
+                sprintf (action,"ACTION=partchk");
+                break;
+        case DASD_HOTPLUG_EVENT_PARTREMOVE:
+                sprintf (action,"ACTION=partremove");
+                break;
+        default:
+                BUG();
+        }
+        envp[i++] = devno;
+        envp[i++] = major;
+        envp[i++] = minor;
+        envp[i++] = devname;
+        envp[i++] = action;
+        envp[i++] = 0;
+        
+        call_usermodehelper (argv [0], argv, envp);
+#endif
+}
+
+
 static int
 dasd_disable_volume ( dasd_device_t * device, int force ) 
 {
@@ -2810,8 +3525,9 @@
         int count = atomic_read (&device->open_count);
         
 	if ( count ) {
-		DASD_MESSAGE (KERN_EMERG, device, "%s",
-			      "device has vanished although it was open!");
+
+		DEV_MESSAGE (KERN_EMERG, device, "%s",
+                             "device has vanished although it was open!");
         }
         if ( force ) {
                 dasd_deactivate_queue(device);
@@ -2824,9 +3540,11 @@
         /* unregister partitions ('ungrok_partitions') */
         devfs_register_partitions(&device->major_info->gendisk,
                                   MINOR(device->kdev),1);
+        dasd_do_hotplug_event (device, DASD_HOTPLUG_EVENT_PARTREMOVE);
         
-        DASD_MESSAGE (KERN_WARNING, device, 
-                      "disabling device, target state: %d",target);
+        DBF_DEV_EVENT (DBF_ERR, device, 
+                       "disabling device, target state: %d",
+                       target);
 
         dasd_set_device_level (device->devinfo.devno, 
                                device->discipline, 
@@ -2836,9 +3554,11 @@
 
 static void
 dasd_disable_ranges (dasd_range_t *range, 
-                     dasd_discipline_t *d,
+                     dasd_discipline_t *discipline,
                      int all, int force ) 
 {
+        dasd_device_t **dptr;
+        dasd_device_t *device;
         dasd_range_t *rrange;
         int j;
 
@@ -2850,22 +3570,24 @@
         }
         do {
                 for (j = rrange->from; j <= rrange->to; j++) {
-                        dasd_device_t **dptr;
-                        dasd_device_t *device;
                         dptr = dasd_device_from_devno(j);
-                        if ( dptr == NULL ) {
+                        if (dptr == NULL) {
                             continue;
                         }
                         device = *dptr;
                         if (device == NULL ||
-                            (d != NULL &&
-                             device -> discipline != d))
+                            (discipline != NULL &&
+                             device -> discipline != discipline))
                                 continue;
                         
                         dasd_disable_volume(device, force);
                 }
+
+                if (rrange->list.next == NULL)
+                        break;
                 rrange = list_entry (rrange->list.next, dasd_range_t, list);
         } while ( all && rrange && rrange != range );
+        
 }
 
 static void 
@@ -2877,10 +3599,13 @@
 }
 
 static void
-dasd_enable_ranges (dasd_range_t *range, dasd_discipline_t *d, int all ) 
+dasd_enable_ranges (dasd_range_t *range, 
+                    dasd_discipline_t *discipline, 
+                    int all) 
 {
         int retries = 0;
 	int j;
+        int do_again;
         kdev_t tempdev;
 	dasd_range_t *rrange;
 
@@ -2888,6 +3613,7 @@
 		return;
         
         do {
+                do_again = 0;
                 if (range == &dasd_range_head) {
                         rrange = list_entry (range->list.next, 
                                              dasd_range_t, list);
@@ -2898,26 +3624,40 @@
                         for (j = rrange->from; j <= rrange->to; j++) {
                                 if ( dasd_devindex_from_devno(j) < 0 )
                                         continue;
-                                dasd_set_device_level (j, d, DASD_STATE_ONLINE);
+                                if (-EAGAIN == dasd_set_device_level 
+                                    (j, discipline, DASD_STATE_ONLINE))
+                                        do_again = 1;
                         }
                         rrange = list_entry (rrange->list.next, dasd_range_t, list);
                 } while ( all && rrange && rrange != range );
 
-                if (atomic_read (&dasd_init_pending) == 0) /* we are done, exit loop */
+                if ((atomic_read (&dasd_init_pending) == 0) &&
+                    (!do_again)) /* we are done, exit loop */
                         break;
 
                 if ( retries == 0 ) {
-                        printk (KERN_INFO PRINTK_HEADER
-                                "waiting for responses...\n");
+
+                        MESSAGE (KERN_INFO, "%s",
+                                 "waiting for responses...");
+
                 } else if ( retries < 5 ) {
-                        printk (KERN_INFO PRINTK_HEADER
-                                "waiting a little bit longer...\n");
+
+                        DBF_EVENT (DBF_NOTICE, "%s",
+                                   "waiting a little bit longer...");
+
                 } else {
-                        printk (KERN_INFO PRINTK_HEADER
-                                "giving up, enable late devices manually!\n");
+
+                        MESSAGE (KERN_INFO, "%s",
+                                 "giving up, enable late devices manually!");
                         break;
                 }
-                interruptible_sleep_on_timeout (&dasd_init_waitq, (1 * HZ));
+
+                /* prevent scheduling if called by bh (timer) */
+                if (!in_interrupt()) {
+                        interruptible_sleep_on_timeout (&dasd_init_waitq, 
+                                                        (1 * HZ)         );
+                }
+
                 retries ++;
         } while (1);
         /* now setup block devices */
@@ -2939,9 +3679,9 @@
                         device = *dptr;
                         if (device == NULL )
                                 continue;
-                        if ( ((d == NULL && device->discipline != NULL) ||
-                              (device->discipline == d )) &&
-                             device->level >= DASD_STATE_READY &&
+                        if ( ((discipline == NULL && device->discipline != NULL) ||
+                              (device->discipline == discipline )) &&
+                             device->level == DASD_STATE_ONLINE &&
                              device->request_queue == NULL ) {
                                 if (dasd_features_from_devno(j)&DASD_FEATURE_READONLY) {
                                         for (tempdev=device->kdev;
@@ -2949,9 +3689,8 @@
                                              tempdev++)
                                                 set_device_ro (tempdev, 1);
 
-                                        printk (KERN_WARNING PRINTK_HEADER 
-                                                "setting read-only mode for device /dev/%s\n",
-                                                device->name);
+                                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                                     "setting read-only mode ");
                                 }
                                 dasd_setup_blkdev(device);
                                 dasd_setup_partitions(device);
@@ -2971,13 +3710,17 @@
 static void
 dasd_not_oper_handler (int irq, int status)
 {
-	dasd_device_t *device = NULL;
-	major_info_t *major_info = NULL;
+	dasd_device_t *device;
+	major_info_t *major_info;
+        ccw_req_t* cqr;
 	struct list_head *l;
-	int i, devno = -ENODEV;
+        unsigned long flags;
+	int i, devno;
 
 	/* find out devno of leaving device: CIO has already deleted this information ! */
-	list_for_each (l, &dasd_major_info[0].list) {
+        devno = -ENODEV;
+	device = NULL;
+	list_for_each (l, &dasd_major_info) {
 		major_info = list_entry (l, major_info_t, list);
 		for (i = 0; i < DASD_PER_MAJOR; i++) {
 			device = major_info->dasd_device[i];
@@ -2990,17 +3733,45 @@
 			break;
 	}
 
-	DASD_DRIVER_DEBUG_EVENT (5, dasd_not_oper_handler, 
-                                 "called for devno %04x", 
-                                 devno);
-
 	if (devno < 0) {
-		printk (KERN_WARNING PRINTK_HEADER
-			"not_oper_handler called on irq 0x%04x no devno!\n", 
-                        irq);
+
+		MESSAGE (KERN_WARNING,
+                         "not_oper_handler called on irq 0x%04x no devno!", 
+                         irq);
 		return;
 	}
-        dasd_disable_volume(device, 1);
+	switch (status) {
+	case DEVSTAT_DEVICE_GONE:
+	case DEVSTAT_REVALIDATE: //FIXME
+		DEV_MESSAGE (KERN_DEBUG, device, "%s", 
+			"device is gone, disabling it permanently\n");
+        	dasd_disable_volume(device, 1);
+		break;
+	case DEVSTAT_NOT_ACC:
+	case DEVSTAT_NOT_ACC_ERR:
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+			"device is not accessible, disabling it temporary\n");                
+                s390irq_spin_lock_irqsave (device->devinfo.irq, 
+                                           flags);
+                device->stopped |= DASD_STOPPED_NOT_ACC;
+
+		if (status == DEVSTAT_NOT_ACC_ERR) {
+			cqr = device->queue.head;
+			while (cqr) {
+				if (cqr->status == CQR_STATUS_QUEUED)
+					break;
+				if (cqr->status == CQR_STATUS_IN_IO)
+					cqr->status = CQR_STATUS_QUEUED;
+				cqr = cqr->next;
+			}
+		}
+                s390irq_spin_unlock_irqrestore(device->devinfo.irq, 
+                                               flags);
+
+		break;
+	default:
+		panic ("dasd not operational handler was called with illegal status\n");
+	}
 }
 
 /*
@@ -3014,56 +3785,54 @@
 {
 	int devno;
 	int rc = 0;
-	major_info_t *major_info = NULL;
-        dasd_range_t *rptr,range;
-        dasd_device_t *device = NULL;
+	major_info_t *major_info;
+        dasd_range_t range;
+        dasd_device_t *device;
 	struct list_head *l;
+	unsigned long flags;
         int i;
 
+
 	devno = get_devno_by_irq (irq);
 	if (devno == -ENODEV) {
 		rc = -ENODEV;
                 goto out;
 	}
 
-	DASD_DRIVER_DEBUG_EVENT (5, dasd_oper_handler, 
-                                 "called for devno %04x", 
-                                 devno);
-
 	/* find out devno of device */
-	list_for_each (l, &dasd_major_info[0].list) {
+	device = NULL;
+	list_for_each (l, &dasd_major_info) {
 		major_info = list_entry (l, major_info_t, list);
 		for (i = 0; i < DASD_PER_MAJOR; i++) {
 			device = major_info->dasd_device[i];
-			if (device && device->devinfo.irq == irq) {
-				devno = device->devinfo.devno;
+			if (device && device->devinfo.irq == irq)
 				break;
-			}
+			else
+                                device = NULL;
 		}
-		if (devno != -ENODEV)
+		if (device)
 			break;
 	}
-	if (devno < 0) {
-                BUG();
-	}
-        if ( device &&
-             device->level == DASD_STATE_READY ) {
-            dasd_set_device_level (device->devinfo.devno, 
-                                   device->discipline, DASD_STATE_ONLINE);
 
+        if (device &&
+            device->level >= DASD_STATE_READY) {
+                s390irq_spin_lock_irqsave (device->devinfo.irq, 
+                                           flags);
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "device is accessible again, reenabling it\n");
+                device->stopped &= ~DASD_STOPPED_NOT_ACC;
+                
+                s390irq_spin_unlock_irqrestore(device->devinfo.irq, 
+                                               flags);
+                dasd_schedule_bh(device);
         } else {
-            if (dasd_autodetect) {
-		rptr = dasd_add_range (devno, devno, DASD_DEFAULT_FEATURES);
-                if ( rptr == NULL ) {
-                    rc = -ENOMEM;
-                    goto out;
+
+                if (dasd_autodetect) {
+                        dasd_add_range (devno, devno, DASD_FEATURE_DEFAULT);
                 }
-            } else {
                 range.from = devno;
                 range.to = devno;
-                rptr = &range;
-            }
-            dasd_enable_ranges (rptr, NULL, 0);
+                dasd_enable_ranges (&range, NULL, 0);
         }
  out:
 	return rc;
@@ -3075,13 +3844,16 @@
 {
         dasd_device_t **device_addr;
 
-	DASD_DRIVER_DEBUG_EVENT (1, dasd_find_device_addr, 
-                                 "devno %04x", 
-                                 devno);
+	DBF_EVENT (DBF_INFO, 
+                   "devno %04x", 
+                   devno);
+
 	if ( dasd_devindex_from_devno (devno) < 0 ) {
-                DASD_DRIVER_DEBUG_EXCEPTION (1, dasd_find_device_addr, 
-                                             "no dasd: devno %04x",
-                                             devno);
+
+                DBF_EXC (DBF_ALERT, 
+                         "no dasd: devno %04x",
+                         devno);
+
 		return NULL;
 	}
         /* allocate major numbers on demand  for new devices */
@@ -3090,9 +3862,8 @@
 
 		if ((rc = dasd_register_major (NULL)) <= 0) {
 
-                        DASD_DRIVER_DEBUG_EXCEPTION (1, dasd_find_device_addr, 
-                                                     "%s",
-                                                     "out of major numbers!");
+                        DBF_EXC (DBF_ALERT, "%s",
+                                 "out of major numbers!");
                         break;
 		}
 	}
@@ -3100,86 +3871,109 @@
 }
 
 static inline int
-dasd_state_del_to_new (dasd_device_t **addr ) 
+dasd_state_del_to_new (dasd_device_t **addr, int devno) 
 {
+        int i;
         dasd_device_t* device;
-        int rc = 0;
-	if (*addr == NULL) { /* allocate device descriptor on demand for new device */
-                device = kmalloc (sizeof (dasd_device_t), GFP_ATOMIC);
-		if (device == NULL ) {
-			rc = -ENOMEM;
-                        goto out;
-		}
-		memset (device, 0, sizeof (dasd_device_t));
+        dasd_lowmem_t *lowmem;
+        int rc;
+
+
+        /* allocate device descriptor on demand for new device */
+	if (*addr != NULL) { 
+                BUG ();
+        }
+
+        device = kmalloc (sizeof (dasd_device_t), GFP_ATOMIC);
+        if (device == NULL) {
+                return -ENOMEM;
+        }
+        
+        memset (device, 0, sizeof (dasd_device_t));
+        dasd_plug_device (device);
+        INIT_LIST_HEAD (&device->lowmem_pool);
+        
+        /* allocate pages for lowmem pool */
+        for (i = 0; i < DASD_LOWMEM_PAGES; i++) {
+                
+                lowmem = (void *) get_free_page (GFP_ATOMIC|GFP_DMA);
+                if (lowmem == NULL) {
+                        break;
+                }
+
+                list_add (&lowmem->list, &device->lowmem_pool);
+        } 
+
+        if (i < DASD_LOWMEM_PAGES) {
+                /* didn't get the needed lowmem pages */
+                list_for_each_entry (lowmem, &device->lowmem_pool, list) {
+                        MESSAGE (KERN_DEBUG,
+                                 "<devno: %04x> not enough memory - "
+                                 "Free page again :%p",
+                                 devno, lowmem);
+                        free_page ((unsigned long) lowmem);
+                }
+                kfree (device);
+                rc = -ENOMEM;
+        } else {
                 *addr = device;
-                device->lowmem_ccws = (void*)get_free_page (GFP_ATOMIC|GFP_DMA);
-                if (device->lowmem_ccws == NULL) {
-                        rc = -ENOMEM;
-                        goto noccw;
-	}
-#ifdef CONFIG_ARCH_S390X
-                device->lowmem_idals =
-                    device->lowmem_idal_ptr = (void*) get_free_page (GFP_ATOMIC|GFP_DMA);
-                if (device->lowmem_idals == NULL) {
-                        rc = -ENOMEM;
-                        goto noidal;
-                }                
-#endif
-}
-        goto out;
-#ifdef CONFIG_ARCH_S390X
- noidal:
-        free_page ((long) device->lowmem_ccws);
-#endif
- noccw:
-        kfree(device);
- out:
+                rc = 0;
+        }
         return rc;
 }
 
 static inline int
-dasd_state_new_to_del (dasd_device_t **addr )
+dasd_state_new_to_del (dasd_device_t **addr, int devno)
 {
+        dasd_lowmem_t *lowmem;
+
         dasd_device_t *device = *addr;
+
+        /* free private area */
         if (device && device->private) {
                 kfree(device->private);
-                device->private = NULL;
         }
-#ifdef CONFIG_ARCH_S390X
-        free_page ((long)(device->lowmem_idals));
-#endif
-        free_page((long)(device->lowmem_ccws));
+
+        /* free lowmem_pool */
+        list_for_each_entry (lowmem, &device->lowmem_pool, list) {
+                free_page ((unsigned long) lowmem);
+        }
+
+        /* free device */
         kfree(device);
         *addr = NULL; 
         return 0;
 }
 
 static inline int
-dasd_state_new_to_known (dasd_device_t **dptr, int devno, dasd_discipline_t *disc) 
+dasd_state_new_to_known (dasd_device_t **dptr, 
+                         int devno, 
+                         dasd_discipline_t *discipline) 
 {
         int rc = 0;
 	umode_t devfs_perm  = S_IFBLK | S_IRUSR | S_IWUSR;
         struct list_head *l;
-        major_info_t *major_info = NULL;
+        major_info_t *major_info, *tmp;
         int i;
         dasd_device_t *device = *dptr;
         devfs_handle_t dir;
         char buffer[5];
         
-
-	list_for_each (l, &dasd_major_info[0].list) {
-                major_info = list_entry (l, major_info_t, list);
+        major_info = NULL;
+	list_for_each (l, &dasd_major_info) {
+                tmp = list_entry (l, major_info_t, list);
 		for (i = 0; i < DASD_PER_MAJOR; i++) {
-			if (major_info->dasd_device[i] == device) {
-				device->kdev = MKDEV (major_info->gendisk.major,
+			if (tmp->dasd_device[i] == device) {
+				device->kdev = MKDEV (tmp->gendisk.major,
                                                       i << DASD_PARTN_BITS);
+                                major_info = tmp;
 				break;
 			}
 		}
-		if (i < DASD_PER_MAJOR) /* we found one */
+		if (major_info != NULL) /* we found one */
 			break;
 	}
-        if ( major_info == NULL || major_info == &dasd_major_info[0] ) 
+        if ( major_info == NULL )
                 BUG();
 
         device->major_info = major_info;
@@ -3192,18 +3986,24 @@
         
         rc = get_dev_info_by_devno (devno, &device->devinfo);
         if ( rc ) {
+                /* returns -EUSERS if boxed !!*/
+                if (rc == -EUSERS) {
+                        device->level = DASD_STATE_BOXED;
+                }
                 goto out;
         }
 
-	DASD_DRIVER_DEBUG_EVENT (5, dasd_state_new_to_known, 
-                                 "got devinfo CU-type %04x and dev-type %04x", 
-                                 device->devinfo.sid_data.cu_type,
-                                 device->devinfo.sid_data.dev_type);
-
+	DBF_EVENT (DBF_NOTICE,
+                   "got devinfo CU-type %04x and dev-type %04x", 
+                   device->devinfo.sid_data.cu_type,
+                   device->devinfo.sid_data.dev_type);
+        
 
         if ( devno != device->devinfo.devno )
                 BUG();
-        device->discipline = dasd_find_disc (device, disc);
+
+        device->discipline = dasd_find_disc (device, 
+                                             discipline);
         if ( device->discipline == NULL ) {
                 rc = -ENODEV;
                 goto out;
@@ -3221,6 +4021,7 @@
                                               MINOR(device->kdev),
                                               devfs_perm,
                                               &dasd_device_operations,NULL);
+        dasd_do_hotplug_event (device, DASD_HOTPLUG_EVENT_ADD);
         device->level = DASD_STATE_KNOWN;
  out:
         return rc;
@@ -3233,7 +4034,7 @@
         /* don't reset to zeros because of persistent data durich detach/attach! */
         devfs_unregister(device->devfs_entry);
         devfs_unregister(device->major_info->gendisk.de_arr[MINOR(device->kdev) >> DASD_PARTN_BITS]);
-
+        dasd_do_hotplug_event (device, DASD_HOTPLUG_EVENT_REMOVE);
         return rc;
 }
 
@@ -3241,21 +4042,38 @@
 dasd_state_known_to_accept (dasd_device_t *device) 
 {
         int rc = 0;
-        device->debug_area = debug_register (device->name, 0, 2, 
-                                             3 * sizeof (long));
-        debug_register_view (device->debug_area, &debug_sprintf_view);
-        debug_register_view (device->debug_area, &debug_hex_ascii_view);
-        DASD_DEVICE_DEBUG_EVENT (0, device,"%p debug area created",
-                                 device);
+
+        /* register 'device' debug area, used for all DBF_DEV_XXX calls*/
+        device->debug_area = debug_register (device->name, 
+                                             0,     /* size of debug area */
+                                             2,     /* number of areas */
+                                             8 * sizeof (long));
+
+        debug_register_view (device->debug_area, 
+                             &debug_sprintf_view);
+
+        debug_set_level (device->debug_area, 
+                         DBF_ERR);
+
+        DBF_DEV_EVENT (DBF_EMERG, device, "%s",
+                       "debug area created");
         
         if (device->discipline->int_handler) {
                 rc = s390_request_irq_special (device->devinfo.irq,
                                                device->discipline->int_handler,
                                                dasd_not_oper_handler,
-                                               0, DASD_NAME,
+                                               SA_DOPATHGROUP, DASD_NAME,
                                                &device->dev_status);
                 if ( rc ) {
-                        printk("No request IRQ\n");
+
+                        MESSAGE (KERN_DEBUG, "%s",
+                                 "No request IRQ");
+
+			if (rc == -EUSERS) {
+				/* Device is reserved by someone else. */
+				device->level = DASD_STATE_BOXED;
+			}
+
                         goto out;
                 }
         }
@@ -3272,10 +4090,15 @@
         if (device->discipline->int_handler) {
                 free_irq (device->devinfo.irq, &device->dev_status);
         }
-        DASD_DEVICE_DEBUG_EVENT (0, device,"%p debug area deleted",
-                                 device);
-        if ( device->debug_area != NULL )
+
+        DBF_DEV_EVENT (DBF_EMERG, device,
+                       "%p debug area deleted",
+                       device);
+
+        if (device->debug_area != NULL) {
                 debug_unregister (device->debug_area);
+                device->debug_area = NULL;  
+        }
         device->discipline = NULL;
         device->level = DASD_STATE_KNOWN;
  out:
@@ -3297,18 +4120,17 @@
                         s390irq_spin_lock_irqsave (device->devinfo.irq, 
                                                    flags);
                         rc = device->discipline->start_IO (device->init_cqr);
+                        if ( ! rc )
+                        	device->level = DASD_STATE_INIT;
                         s390irq_spin_unlock_irqrestore(device->devinfo.irq, 
                                                        flags);
-                        if ( rc )
-                                goto out;
-                        device->level = DASD_STATE_INIT;
                 } else {
                         rc = -ENOMEM;
                 }
         } else {
                 rc = dasd_state_init_to_ready ( device ); 
         }
- out:
+
         return rc;
 }
 
@@ -3318,15 +4140,8 @@
         int rc = 0;    
         if (device->discipline->do_analysis != NULL)
                 if ( device->discipline->do_analysis (device) == 0 ) 
-                        switch (device->sizes.bp_block) {
-                        case 512:
-                        case 1024:
-                        case 2048:
-                        case 4096:
-                                break;
-                        default:
-                                rc = -EMEDIUMTYPE;
-                        }
+                        rc = dasd_check_bp_block (device);
+        
         if ( device->init_cqr ) {
                 /* This pointer is no longer needed, BUT dont't free the       */ 
                 /* memory, because this is done in bh for finished request!!!! */
@@ -3362,8 +4177,10 @@
 dasd_state_ready_to_online (dasd_device_t *device ) 
 {
         int rc = 0;
-        dasd_unplug_device (device);
-        device->level = DASD_STATE_ONLINE;
+        if (!(rc = dasd_check_bp_block (device))) {
+                dasd_unplug_device (device);
+                device->level = DASD_STATE_ONLINE;
+        }
         return rc;
 }
 
@@ -3383,6 +4200,7 @@
         int i;
         int major = MAJOR(device->kdev);
         int minor = MINOR(device->kdev);
+        request_queue_t *request_queue;
 
         for (i = 0; i < (1 << DASD_PARTN_BITS); i++) {
                 if (i == 0)
@@ -3399,11 +4217,16 @@
 		device->major_info->gendisk.part[minor+i].start_sect = 0;
 		device->major_info->gendisk.part[minor+i].nr_sects = 0;
         }
-        device->request_queue = kmalloc(sizeof(request_queue_t),GFP_KERNEL);
-        device->request_queue->queuedata = device;
-        blk_init_queue (device->request_queue, do_dasd_request);
-        blk_queue_headactive (device->request_queue, 0);
-        elevator_init (&(device->request_queue->elevator),ELEVATOR_NOOP);
+
+        request_queue = kmalloc(sizeof(request_queue_t),GFP_KERNEL);
+        if (request_queue) {
+                request_queue->queuedata = device;
+                blk_init_queue (request_queue, do_dasd_request);
+                blk_queue_headactive (request_queue, 1);
+                elevator_init (&(request_queue->elevator),ELEVATOR_NOOP);
+        }
+        device->request_queue = request_queue;
+        
         return rc;
 }
 
@@ -3424,6 +4247,19 @@
         int i;
         int major = MAJOR(device->kdev);
         int minor = MINOR(device->kdev);
+	request_queue_t *q   = device->request_queue;
+	struct request  *req;
+	long             flags;
+
+	spin_lock_irqsave(&io_request_lock, flags);
+	while (q                           &&
+               !list_empty(&q->queue_head) &&
+               (req = dasd_next_request(q)) != NULL) {
+
+		dasd_end_request(req, 0);
+		dasd_dequeue_request(q, req);
+	}
+	spin_unlock_irqrestore(&io_request_lock, flags);
 
         for (i = 0; i < (1 << DASD_PARTN_BITS); i++) {
                 destroy_buffers(MKDEV(major,minor+i));
@@ -3453,6 +4289,7 @@
 		       1 << DASD_PARTN_BITS,
 		       &dasd_device_operations,
 		       (device->sizes.blocks << device->sizes.s2b_shift));
+        dasd_do_hotplug_event (device, DASD_HOTPLUG_EVENT_PARTCHK);
 }
 
 static inline void
@@ -3467,14 +4304,7 @@
         }
         devfs_register_partitions(&device->major_info->gendisk,
                                   MINOR(device->kdev),1);
-}
-
-static inline void
-dasd_resetup_partitions ( dasd_device_t * device ) 
-{
-    BUG();
-    dasd_destroy_partitions ( device ) ;
-    dasd_setup_partitions ( device ) ;
+        dasd_do_hotplug_event (device, DASD_HOTPLUG_EVENT_PARTREMOVE);
 }
 
 /*
@@ -3505,11 +4335,11 @@
                 from_state = device->level;
         }
 
-        DASD_DRIVER_DEBUG_EVENT (3, dasd_set_device_level,
-                                 "devno %04x; from %i to %i",
-                                 devno,
-                                 from_state,
-                                 to_state);
+        DBF_EVENT (DBF_INFO,
+                   "devno %04x; from %i to %i",
+                   devno,
+                   from_state,
+                   to_state);
 
         if ( from_state == to_state )
                 goto out;
@@ -3520,20 +4350,30 @@
         /* First check for bringup */
         if ( from_state <= DASD_STATE_DEL &&
              to_state >= DASD_STATE_NEW ) { 
-                rc = dasd_state_del_to_new(device_addr);
+                rc = dasd_state_del_to_new(device_addr, devno);
                 if ( rc ) {
                         goto bringup_fail;
                 }
                 device = *device_addr;
         }
-        if ( from_state <= DASD_STATE_NEW &&
+
+        /* reprobe boxed devices */
+        if (device->level == DASD_STATE_BOXED) {
+                rc = s390_trigger_resense (device->devinfo.irq);
+                if ( rc ) {
+                        goto bringup_fail;
+                }
+        }
+
+        if ( device->level <= DASD_STATE_BOXED &&
              to_state >= DASD_STATE_KNOWN ) { 
                 rc = dasd_state_new_to_known( device_addr, devno, discipline );
                 if ( rc ) {
                         goto bringup_fail;
                 }
         }
-        if ( from_state <= DASD_STATE_KNOWN &&
+
+        if ( device->level <= DASD_STATE_KNOWN &&
              to_state >= DASD_STATE_ACCEPT ) { 
                 rc = dasd_state_known_to_accept(device);
                 if ( rc ) {
@@ -3543,19 +4383,21 @@
         if ( dasd_probeonly ) {
             goto out;
         }
-        if ( from_state <= DASD_STATE_ACCEPT &&
+
+        if ( device->level <= DASD_STATE_ACCEPT &&
              to_state >= DASD_STATE_INIT ) { 
                 rc = dasd_state_accept_to_init(device);
                 if ( rc ) {
                         goto bringup_fail;
                 }
         }
-        if ( from_state <= DASD_STATE_INIT &&
+        if ( device->level <= DASD_STATE_INIT &&
              to_state >= DASD_STATE_READY ) { 
                 rc = -EAGAIN;
                 goto out;
         }
-        if ( from_state <= DASD_STATE_READY &&
+
+        if ( device->level <= DASD_STATE_READY &&
              to_state >= DASD_STATE_ONLINE ) { 
                 rc = dasd_state_ready_to_online(device);
                 if ( rc ) {
